var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { Machine, assign } from 'xstate';
var initial = {
    message: null,
    sizes: [1, 10, 100],
    storyName: 'unknown',
    current: {
        results: null,
        samples: 1,
        copies: 1,
    },
    pinned: null,
};
var machine = Machine({
    id: 'panel',
    initial: 'waiting',
    context: initial,
    states: {
        waiting: {
            entry: assign(function () { return initial; }),
            on: {
                LOADED: {
                    target: 'active',
                    actions: assign(function (context, event) {
                        var message = event.pinned
                            ? "Loaded pinned result for story: " + event.storyName
                            : null;
                        return __assign(__assign({}, context), { message: message, pinned: event.pinned, storyName: event.storyName, current: event.pinned || context.current });
                    }),
                },
            },
        },
        active: {
            id: 'active',
            initial: 'idle',
            on: {
                WAIT: '#panel.waiting',
            },
            states: {
                idle: {
                    exit: 'clearMessage',
                    on: {
                        START_ALL: 'running',
                        START_ONE: 'running',
                        SET_VALUES: {
                            internal: true,
                            target: 'idle',
                            cond: function (context) {
                                return context.pinned == null;
                            },
                            actions: [
                                'clearMessage',
                                assign({
                                    current: function (context, event) {
                                        return {
                                            results: null,
                                            storyName: context.storyName,
                                            samples: event.samples,
                                            copies: event.copies,
                                        };
                                    },
                                }),
                            ],
                        },
                        PIN: {
                            internal: true,
                            target: 'idle',
                            cond: function (context) {
                                return context.current.results != null;
                            },
                            actions: assign(function (context) {
                                return __assign(__assign({}, context), { pinned: context.current, message: 'Result pinned' });
                            }),
                        },
                        UNPIN: {
                            internal: true,
                            target: 'idle',
                            cond: function (context) {
                                return context.pinned != null;
                            },
                            actions: assign(function (context) {
                                return __assign(__assign({}, context), { pinned: null, message: 'Pinned result removed' });
                            }),
                        },
                    },
                },
                running: {
                    on: {
                        FINISH: {
                            target: 'idle',
                            actions: assign({
                                current: function (context, event) {
                                    var current = __assign(__assign({}, context.current), { results: event.results });
                                    return current;
                                },
                            }),
                        },
                    },
                },
            },
        },
    },
}, {
    actions: {
        clearMessage: assign(function (context) {
            return __assign(__assign({}, context), { message: null });
        }),
    },
});
export default machine;
