var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import { styled } from '@storybook/theming';
import React from 'react';
import all from '../tasks/all';
import machine from './machine';
import ServiceContext from './service-context';
import TaskGroupPanel from './task-group';
import Topbar from './top-bar';
import usePanelMachine from './use-panel-machine';
var Container = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  --grid: 10px;\n  --halfGrid: calc(var(--grid) / 2);\n\n  font-size: 16px;\n  line-height: 1.5;\n"], ["\n  --grid: 10px;\n  --halfGrid: calc(var(--grid) / 2);\n\n  font-size: 16px;\n  line-height: 1.5;\n"])));
var GroupContainer = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  display: grid;\n  grid-template-columns: repeat(3, minmax(0, 1fr));\n  min-height: 100%;\n  padding: 0 var(--halfGrid);\n"], ["\n  display: grid;\n  grid-template-columns: repeat(3, minmax(0, 1fr));\n  min-height: 100%;\n  padding: 0 var(--halfGrid);\n"])));
function findResult(group, context) {
    if (!context || !context.results) {
        return null;
    }
    var result = context.results.find(function (item) { return item.groupId === group.groupId; });
    return result || null;
}
function getResult(group, context) {
    var result = findResult(group, context);
    if (!result) {
        throw new Error("Could not find group(" + group.name + ") in result");
    }
    return result;
}
export default function Panel(_a) {
    var channel = _a.channel;
    var _b = usePanelMachine(machine, channel), state = _b.state, service = _b.service;
    return (React.createElement(ServiceContext.Provider, { value: service },
        React.createElement(Container, null,
            React.createElement(Topbar, null),
            React.createElement(GroupContainer, null, all.groups.map(function (group) {
                if (state.context.current.results == null) {
                    return null;
                }
                return (React.createElement(TaskGroupPanel, { key: group.groupId, group: group, result: getResult(group, state.context.current), pinned: findResult(group, state.context.pinned) }));
            })))));
}
var templateObject_1, templateObject_2;
