var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import React, { useCallback, useState } from 'react';
import { styled } from '@storybook/theming';
import * as Expand from './parts';
import { Button, Icons } from '@storybook/components';
import { useService } from '@xstate/react';
import useRequiredContext from '../../use-required-context';
import ServiceContext from '../service-context';
import { pluraliseCopies, pluraliseSamples } from '../../util/pluralise';
import nextEventsInclude from '../next-events-include';
var Container = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  --result-border-radius: 4px;\n  margin-bottom: var(--grid);\n  border: 1px solid lightgray;\n  border-radius: var(--result-border-radius);\n"], ["\n  --result-border-radius: 4px;\n  margin-bottom: var(--grid);\n  border: 1px solid lightgray;\n  border-radius: var(--result-border-radius);\n"])));
var HeaderButton = styled.button(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  /* reset */\n  margin: 0;\n  padding: 0;\n  border: none;\n\n  width: 100%;\n  height: calc(var(--grid) * 4);\n  text-align: left;\n  font-size: 16px;\n  font-weight: bold;\n  border-radius: var(--result-border-radius);\n\n  background-color: ", ";\n\n  display: flex;\n  align-items: center;\n  padding: 0 var(--grid);\n\n  > * {\n    margin-left: var(--grid);\n    flex-shrink: 0;\n\n    &:first-child {\n      margin-left: 0;\n    }\n  }\n"], ["\n  /* reset */\n  margin: 0;\n  padding: 0;\n  border: none;\n\n  width: 100%;\n  height: calc(var(--grid) * 4);\n  text-align: left;\n  font-size: 16px;\n  font-weight: bold;\n  border-radius: var(--result-border-radius);\n\n  background-color: ", ";\n\n  display: flex;\n  align-items: center;\n  padding: 0 var(--grid);\n\n  > * {\n    margin-left: var(--grid);\n    flex-shrink: 0;\n\n    &:first-child {\n      margin-left: 0;\n    }\n  }\n"])), function (props) { return props.theme.background.content; });
var Name = styled.h4(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  /* the name will push the result over, it can also collapse when there is no room */\n  flex-grow: 1;\n  flex-shrink: 1;\n  font-weight: bold;\n\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n"], ["\n  /* the name will push the result over, it can also collapse when there is no room */\n  flex-grow: 1;\n  flex-shrink: 1;\n  font-weight: bold;\n\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n"])));
var IconContainer = styled.span(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  width: var(--grid);\n  height: var(--grid);\n"], ["\n  width: var(--grid);\n  height: var(--grid);\n"])));
function ExpandIcon(_a) {
    var isExpanded = _a.isExpanded;
    return (React.createElement(IconContainer, null,
        React.createElement(Icons, { icon: isExpanded ? 'arrowdown' : 'arrowright' })));
}
export function ExpandingResult(_a) {
    var taskId = _a.taskId, name = _a.name, result = _a.result, getExpanded = _a.getExpanded;
    var _b = useState(false), isExpanded = _b[0], setIsExpanded = _b[1];
    var toggle = useCallback(function () { return setIsExpanded(function (value) { return !value; }); }, [setIsExpanded]);
    var service = useRequiredContext(ServiceContext);
    var _c = useService(service), state = _c[0], send = _c[1];
    var expanded = getExpanded({ isExpanded: isExpanded });
    var _d = state.context.current, copies = _d.copies, samples = _d.samples;
    return (React.createElement(Container, null,
        React.createElement(HeaderButton, { onClick: toggle, isExpanded: isExpanded },
            React.createElement(ExpandIcon, { isExpanded: isExpanded }),
            React.createElement(Name, null, name),
            result),
        isExpanded ? (React.createElement(Expand.Section, null,
            React.createElement(Button, { secondary: true, small: true, disabled: !nextEventsInclude('START_ONE', state.nextEvents), onClick: function () { return send({ type: 'START_ONE', taskId: taskId }); } },
                "Run task",
                ' ',
                React.createElement("small", null,
                    "(",
                    copies,
                    " ",
                    pluraliseCopies(copies),
                    ", ",
                    samples,
                    " ",
                    pluraliseSamples(samples),
                    ")")),
            expanded)) : null));
}
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
