import React from 'react';
import * as Parts from './parts';
import { ExpandingResult } from './expanding-result';
function DiffToPinned(_a) {
    var task = _a.task, result = _a.result, pinned = _a.pinned;
    if (pinned == null) {
        return null;
    }
    return (React.createElement(React.Fragment, null,
        React.createElement(Parts.Heading, null, "Compared with pinned"),
        React.createElement(Parts.Content, null,
            React.createElement(Parts.Table, null,
                React.createElement("tbody", null,
                    React.createElement("tr", null,
                        React.createElement(Parts.TitleCell, null, "Pinned value"),
                        React.createElement(Parts.ValueCell, null,
                            React.createElement(Parts.ValueLozenge, { type: "raw" },
                                pinned.value,
                                task.scale))),
                    React.createElement("tr", null,
                        React.createElement(Parts.TitleCell, null, "Current value"),
                        React.createElement(Parts.ValueCell, null,
                            React.createElement(Parts.ValueLozenge, { type: pinned.value === result.value ? 'raw' : 'info' },
                                pinned.value,
                                task.scale))))))));
}
function Expanded(_a) {
    var task = _a.task, result = _a.result, pinned = _a.pinned;
    return (React.createElement(React.Fragment, null,
        React.createElement(DiffToPinned, { task: task, result: result, pinned: pinned }),
        React.createElement(Parts.Heading, null, "Description"),
        React.createElement(Parts.Content, null, task.description)));
}
export default function Static(_a) {
    var task = _a.task, result = _a.result, pinned = _a.pinned;
    var resultNode = (React.createElement(React.Fragment, null,
        pinned && pinned.value !== result.value ? (React.createElement(Parts.ValueLozenge, { type: "info" },
            pinned.value,
            task.scale)) : null,
        React.createElement(Parts.ResultValue, null, result.value),
        ' ',
        React.createElement(Parts.ResultScale, null, task.scale)));
    return (React.createElement(ExpandingResult, { taskId: task.taskId, name: task.name, result: resultNode, getExpanded: function (_a) {
            var isExpanded = _a.isExpanded;
            return isExpanded ? (React.createElement(Expanded, { task: task, result: result, pinned: pinned })) : null;
        } }));
}
