var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import { Button, Form, Icons } from '@storybook/components';
import { styled } from '@storybook/theming';
import React from 'react';
import useRequiredContext from '../use-required-context';
import ServiceContext from './service-context';
import { useService } from '@xstate/react';
import { pluraliseCopies, pluraliseSamples } from '../util/pluralise';
import nextEventsInclude from './next-events-include';
var Container = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n  align-items: center;\n\n  > * {\n    margin: var(--halfGrid) !important;\n    flex-shrink: 0;\n  }\n"], ["\n  display: flex;\n  align-items: center;\n\n  > * {\n    margin: var(--halfGrid) !important;\n    flex-shrink: 0;\n  }\n"])));
var Message = styled.small(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n  flex-shrink: 1;\n  flex-grow: 1;\n"], ["\n  text-overflow: ellipsis;\n  overflow: hidden;\n  white-space: nowrap;\n  flex-shrink: 1;\n  flex-grow: 1;\n"])));
export default function Topbar() {
    var service = useRequiredContext(ServiceContext);
    var _a = useService(service), state = _a[0], send = _a[1];
    var current = state.context.current;
    var pinned = state.context.pinned;
    var sizes = state.context.sizes;
    var enabled = {
        start: nextEventsInclude('START_ALL', state.nextEvents),
        change: nextEventsInclude('SET_VALUES', state.nextEvents) && pinned == null,
        pin: nextEventsInclude('PIN', state.nextEvents) && current.results != null,
        unpin: nextEventsInclude('UNPIN', state.nextEvents) && current.results != null,
    };
    return (React.createElement(Container, null,
        React.createElement(Button, { primary: true, small: true, onClick: function () { return send({ type: 'START_ALL' }); }, disabled: !enabled.start }, "START ALL"),
        React.createElement(Form.Select, { disabled: !enabled.change, value: current.copies, onChange: function (event) {
                var values = {
                    samples: current.samples,
                    copies: Number(event.target.value),
                };
                send('SET_VALUES', values);
            } }, sizes.map(function (size) { return (React.createElement("option", { key: size, value: size },
            size,
            " ",
            pluraliseCopies(size))); })),
        React.createElement(Form.Select, { disabled: !enabled.change, value: current.samples, onChange: function (event) {
                var values = {
                    copies: current.copies,
                    samples: Number(event.target.value),
                };
                send('SET_VALUES', values);
            } },
            ">",
            sizes.map(function (size) { return (React.createElement("option", { key: size, value: size },
                size,
                " ",
                pluraliseSamples(size))); })),
        React.createElement(Button, { secondary: true, small: true, outline: true, disabled: pinned ? !enabled.unpin : !enabled.pin, onClick: function () { return send({ type: pinned ? 'UNPIN' : 'PIN' }); } },
            React.createElement(Icons, { icon: pinned ? 'unlock' : 'lock' }),
            pinned ? 'Unpin baseline result' : 'Pin result as baseline'),
        React.createElement(Message, null, state.context.message)));
}
var templateObject_1, templateObject_2;
