export function bind(channel, binding) {
    channel.on(binding.eventName, binding.fn);
    return function unbind() {
        channel.off(binding.eventName, binding.fn);
    };
}
export function bindAll(channel, bindings) {
    var unbinds = bindings.map(function (binding) { return bind(channel, binding); });
    return function unbindAll() {
        unbinds.forEach(function (unbind) { return unbind(); });
    };
}
